package view;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.channels.FileChannel.MapMode;
import java.util.Properties;

import javax.imageio.ImageIO;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

import extract.AnimFile;
import extract.BKSprite;
import extract.BKTiles;
import extract.BoxFile;
import extract.PakExtract;
import extract.TileFile;

public class BKSpriteView extends JPanel implements KeyListener, ItemListener, ActionListener, WindowListener, MouseListener, MouseMotionListener {
	/**
	 * 
	 */
	Point tempaxis,start,end;
	public void mouseClicked(MouseEvent e)
	{
		
	}
	public void mouseMoved(MouseEvent e)
	{
		
	}
	public void mouseDragged(MouseEvent e)
	{
		end = e.getPoint();
		double deltax = end.getX()-start.getX();
		double deltay = end.getY()-start.getY();
		axisx = (int)deltax + (int)tempaxis.getX();
		axisy = (int)deltay + (int)tempaxis.getY();
		repaint();
	}
	public void mouseReleased(MouseEvent e)
	{
		
	}
	public void mouseEntered(MouseEvent e)
	{
		
	}
	public void mousePressed(MouseEvent e)
	{
		tempaxis = new Point(axisx,axisy);
		start = e.getPoint();
	}
	public void mouseExited(MouseEvent e)
	{
		
	}
	
	int axisx=256,axisy=180,spraxisx=0,spraxisy=0;
	
	private static final long serialVersionUID = 1L;
	JFrame parent;
	static JMenuBar menu;
	JFileChooser fileChooser;
	static Properties properties = new Properties();
	BKTiles images;
	BoxFile boxes;
	AnimFile anims;
	PakExtract metadata;
	TileFile sprites;
	int selected = 0;
	int palette = 0;
	BKSprite img;
	BufferedImage pal,picimg;
	File selectedFolder;
	File[] pics;
	boolean viewPics = false;
	JComboBox charlist = new JComboBox(Character.values());
	
	BKSpriteView(JFrame parent)
	{
		this.parent = parent;
		initGUI();
		try {
		    properties.load(new FileInputStream("preferences.properties"));
		} catch (Exception e) {
		}
		fileChooser = new JFileChooser();
		fileChooser.setSelectedFile(new File(properties.getProperty("dir","/")));
	}
	void initGUI()
	{
		parent.setTitle("Bonno Kaiho Sprite Viewer");
		addKeyListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);
		setFocusable(true);
		setPreferredSize(new Dimension(512,256));
		menu = new JMenuBar();
		
		JMenu file = new JMenu("File");
		JMenuItem load = new JMenuItem("Load Folder");
		load.addActionListener(this);
		
		JCheckBoxMenuItem seePics = new JCheckBoxMenuItem("View Pic Files");
		seePics.setMnemonic(KeyEvent.VK_P);
		seePics.addItemListener(this);
		
		file.add(load);
		file.addSeparator();
		file.add(seePics);
		menu.add(file);

		JMenu output = new JMenu("Output");
		JMenuItem save = new JMenuItem("Save Current Sprite");
		save.addActionListener(this);
		JMenuItem saveAll = new JMenuItem("Save All Sprites");
		saveAll.addActionListener(this);
		
		output.add(save);
		output.add(saveAll);
		menu.add(output);
		charlist.addItemListener(this);
		add(charlist,BorderLayout.PAGE_START);
		charlist.setFocusable(false);
	}
	void loadImage()
	{
		if(viewPics)
		{
			picimg = PicFile.makeImage(openFile(pics[selected]));
			spraxisx = 0;
			spraxisy = 0;
			System.out.println("Loading "+pics[selected].getName());
		}
		else
		{
			System.out.println(selected);
			if(images == null || sprites == null)
				return;
			img = sprites.buildImage(images, selected);
			/*int palNum = sprites.getPalGroup(selected);
			IndexColorModel colorModel = pak.getPalette(palette,palNum);
			img = sprites.makeSprite(selected, ttc, colorModel);
			pal = DATile.makePaletteImage(colorModel);*/
		}
		repaint();
	}
	protected void paintComponent(Graphics g)
	{
		g.setColor(Color.MAGENTA);
		g.fillRect(0, 0, getWidth(), getHeight());
		if(viewPics){
			if(picimg != null)
			{
				g.drawImage(picimg, axisx+0, axisy+0, null);
			}}
		else
		if(img != null)
		{
			for(int n = 0;n < img.getNumImages();n++)
			{
				g.drawImage(img.getImage(n), axisx+img.getOffX(n), axisy+img.getOffY(n), null);
			}
			g.setColor(Color.blue);
			Rectangle[] clsns = boxes.getBoxes(selected);
			if(clsns != null)
			for(Rectangle r:clsns)
			{
				g.drawRect((int)r.getX()+axisx,
						(int)r.getY()+axisy,
						(int)r.getWidth(),
						(int)r.getHeight());				
			}
			g.setColor(Color.red);
			clsns = boxes.getAttackBoxes(selected);
			if(clsns != null)
			for(Rectangle r:clsns)
			{
				g.drawRect((int)r.getX()+axisx,
						(int)r.getY()+axisy,
						(int)r.getWidth(),
						(int)r.getHeight());				
			}
		}
		if(pal != null)
		{
			g.drawImage(pal, axisx,axisy,null);
		}
	}
	public static void main(String[] args)throws IOException
	{
		JFrame window = new JFrame();
		BKSpriteView tileView = new BKSpriteView(window);
		window.setContentPane(tileView);
		window.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		window.addWindowListener(tileView);
		window.setJMenuBar(menu);
		window.setResizable(true);
		window.pack();
		window.setVisible(true);
	}
	MappedByteBuffer openFile(String location)
	{
		File f = new File(location);
		if(f.exists())
		{
			return openFile(f);
		}
		else
		{
			System.err.println(location+"  does not exist.");
		}
		return null;
	}
	MappedByteBuffer openFile(File f)
	{
		try{
			FileChannel fc = new FileInputStream(f).getChannel();
			return fc.map(MapMode.READ_ONLY, 0, fc.size());
		} catch(IOException e)
		{
			System.err.println("Error opening file!");
			e.printStackTrace();
		}
		return null;
	}
	void setCharacter()
	{
		if(selectedFolder == null)
			return;
		if(!selectedFolder.exists())
			return;
		PakExtract imgfile = new PakExtract();
        String location = String.format("%s/%s.pak", 
        		selectedFolder.getAbsolutePath(),
        		((Character)charlist.getSelectedItem()).getTag());
        imgfile.setBuffer(openFile(location));
        images = new BKTiles(imgfile);
        
        metadata = new PakExtract();
        location = String.format("%s/%s_bin.pak", 
        		selectedFolder.getAbsolutePath(),
        		((Character)charlist.getSelectedItem()).getTag());
        metadata.setBuffer(openFile(location));
        
        sprites = new TileFile(metadata.getFile(new Integer(0)));
        boxes = new BoxFile(metadata.getFile(new Integer(2)));
        //anims = new AnimFile(metadata.getFile(new Integer(1)));
	}
	@Override
	public void actionPerformed(ActionEvent arg0) {
		String event = arg0.getActionCommand();
		if(event.equals("Load Folder"))
		{
			fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			int returnVal = fileChooser.showOpenDialog(this);
	        if(returnVal == JFileChooser.APPROVE_OPTION) {
	        	selectedFolder = fileChooser.getSelectedFile();
	        	
	        	setCharacter();
	        	properties.setProperty("dir",selectedFolder.getPath());
		        
	        	pics = selectedFolder.listFiles(new PicFilter());
	        	
		        loadImage();
	        }
		}
		else if(event.equals("Save Current Sprite"))
		{
			try {
				if(viewPics)
				ImageIO.write(picimg, "png", new File(String.format("%s_%d.png", charlist.getSelectedItem(), selected)));
				else
				{
					for(int n = 0;n < img.getNumImages();n++)
					{
						ImageIO.write(img.getImage(n), "png", new File(String.format("%s_%d_%d.png", charlist.getSelectedItem(), selected,n)));
					}
				}
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		else if(event.equals("Save All Sprites"))
		{
			int max = sprites.getNumSprites();
			File outFolder = new File("output");
			outFolder.mkdir();
			int[] dimensions = sprites.getIdealSize();
			for(int n = 0;n < max;n++)
			{
				if(!sprites.spriteExists(n))
					continue;
				if(images == null || sprites == null)
					return;
				img = sprites.buildImage(images, n);
				for(int m = 0;m < img.getNumImages();m++)
				{
					BufferedImage bi = new BufferedImage(dimensions[0],dimensions[1],BufferedImage.TYPE_INT_ARGB);
					Graphics g = bi.getGraphics();
					g.drawImage(img.getImage(m), dimensions[2]+img.getOffX(m), dimensions[3]+img.getOffY(m), null);
					try {
						if(img.getNumImages() > 1)
							ImageIO.write(bi, "png", new File(String.format("output/%s_%d_%d.png", charlist.getSelectedItem(), n,m)));
						else
							ImageIO.write(bi, "png", new File(String.format("output/%s_%d.png", charlist.getSelectedItem(), n)));
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
			try {
				PrintStream p = new PrintStream(new FileOutputStream("output/axis.txt"));
				p.println(String.format("Axis: %d, %d",dimensions[2],dimensions[3]));
				p.close();
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}
	}
	@Override
	public void windowClosing(WindowEvent arg0) {
		try {
		    properties.store(new FileOutputStream("preferences.properties"),null);
		} catch (Exception e) {
		}
		System.exit(0);
	}
	@Override
	public void windowDeactivated(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowDeiconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowIconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowOpened(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowActivated(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowClosed(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void keyPressed(KeyEvent arg0) {
		int code = arg0.getKeyCode();
		int max;
		if(sprites == null)
			return;
		int prev = selected;
		switch(code)
		{
			case KeyEvent.VK_A:
				if(viewPics)
				{
					max = pics.length;
					if(selected < max-1)
						selected++;
				}
				else
				{
					max = sprites.getNumSprites();
					if(selected < max-1)
						selected++;
					while(!sprites.spriteExists(selected))
					{
						if(selected >= max-1)
						{
							selected=prev;
							break;
						}
						selected++;
					}
				}
				break;
			/*case KeyEvent.VK_S:
				max = pak.getNumPalettes();
				if(palette < max-1)
					palette++;
				break;*/
			case KeyEvent.VK_Z:
				if(selected > 0)
					selected--;
				if(!viewPics)
				{
					while(!sprites.spriteExists(selected))
					{
						if(selected < 0)
						{
							selected=prev;
							break;
						}
						selected--;
					}
				}
				break;
			/*case KeyEvent.VK_X:
				if(palette > 0)
					palette--;
				break;*/
		}
		loadImage();
	}
	@Override
	public void keyReleased(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void keyTyped(KeyEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	public void itemStateChanged(ItemEvent arg0) {
		Object item = arg0.getSource();
		if(item == charlist)
		{
			setCharacter();
		}
		else if(item instanceof JCheckBoxMenuItem)
		{
			viewPics = ((JCheckBoxMenuItem)item).getState();
			if(viewPics) {
				remove(charlist);
				axisx = 0;
				axisy = 0;
			}
			else {
				add(charlist,BorderLayout.PAGE_START);
				axisx = 256;
				axisy = 180;
			}
		}
		
		
		selected = 0;
		loadImage();
	}
}

class PicFilter implements FileFilter
{
	@Override
	public boolean accept(File arg0) {
		return arg0.getName().contains(".pic");
	}
}
