package view;

import java.awt.image.BufferedImage;
import java.awt.image.DataBuffer;
import java.awt.image.DataBufferByte;
import java.awt.image.IndexColorModel;
import java.awt.image.Raster;
import java.awt.image.WritableRaster;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PicFile {
	public static BufferedImage makeImage(ByteBuffer bb)
	{
		bb.order(ByteOrder.LITTLE_ENDIAN);
		int width = bb.getChar();
		int height = bb.getChar();
		System.out.println(width+", "+height);
		byte[] filler = new byte[60];
		bb.get(filler);
		
		byte[] paldata = new byte[1024];
		bb.get(paldata);
		paldata = fixAlphas(paldata);
		IndexColorModel palette = new IndexColorModel(8,256,paldata,0,true);
		
		byte[] rasterData = new byte[width*height];
		bb.get(rasterData);
		DataBuffer db = new DataBufferByte(rasterData, width*height); 
		WritableRaster raster = Raster.createWritableRaster(palette.createCompatibleSampleModel(width,height), db, null);
		return new BufferedImage(palette, raster, false, null);
	}
	static byte[] fixAlphas(byte[] input)
	{
		for(int n = 0;n < 256;n++)
		{
			int alphaVal = (input[n*4+3]&0xff)*2;
			if(alphaVal > 255)
				alphaVal = 255;
			input[n*4+3] = (byte) alphaVal;
		}
		return input;
	}
}
